#include "sqi.h"

int _sqiFlagPKEYColumns( HSQITABLE hTable, char *pszPKEY );

int _sqiOpenDatabase( HLST *phTables, char *pszCatalogFile )
{
	HINI		hIni;
	char		szTableName[INI_MAX_OBJECT_NAME+1];
	char		szProperty[INI_MAX_PROPERTY_NAME+1];
	char		szTableFile[INI_MAX_PROPERTY_VALUE+1];
	char		szPKEY[INI_MAX_PROPERTY_VALUE+1];
	HSQITABLE	hTable;

	*phTables	= lstOpen();
	lstSetFreeFunc( *phTables, _sqiCloseTable );

	if ( iniOpen( &hIni, pszCatalogFile, ';', '[', ']', '=', false ) != INI_SUCCESS )
		return false;
	
	*szTableName = '\0';
	iniObjectFirst( hIni );
	while ( !iniObjectEOL( hIni ) )
	{
		iniObject( hIni, szTableName );

		*szTableFile	= '\0';
		*szPKEY			= '\0';
		iniPropertyFirst( hIni );
		while ( !iniPropertyEOL( hIni ) )
		{
			iniProperty( hIni, szProperty );

			if ( strcasecmp( szProperty, "FILE" ) == 0 )
				iniValue( hIni, szTableFile );

			if ( strcasecmp( szPKEY, "PKEY" ) == 0 )
				iniValue( hIni, szPKEY );

			iniPropertyNext( hIni );
		}

		if ( *szTableName && *szTableFile )
		{

			if ( _sqiOpenTable( &hTable, pszCatalogFile, szTableName, szTableFile ) )
				lstAppend( *phTables, hTable );

		}

		*szTableName = '\0';
		iniObjectNext( hIni );
	}
	
	iniClose( hIni );

	return true;
}


int _sqiFlagPKEYColumns( HSQITABLE hTable, char *pszPKEY )
{
	int			nColumn;
	char		szColumn[255];
	HSQICOLUMN	pColumn;

	if ( !pszPKEY )
		return false;
	
	while ( iniElement( pszPKEY, ',', '\0', nColumn, szColumn, sizeof(szColumn) ) == INI_SUCCESS )
	{
		lstFirst( hTable->hColHdrs );
		while ( !lstEOL( hTable->hColHdrs ) )
		{
			pColumn = (HSQICOLUMN)lstGet( hTable->hColHdrs );
			if ( strcmp( pColumn->pszSQL_DESC_BASE_COLUMN_NAME, szColumn ) == 0 )
			{
				pColumn->bPimaryKey = true;
			}
			lstNext( hTable->hColHdrs );
		}

		nColumn++;
	}

	return true;
}


