#include "sqi.h"

/********************************************
 * sqiCloseStmt
 *
 ********************************************/
int sqiCloseStmt( HSQISTMT hStmt )
{
	HSQI 	hSQI;

	if ( !hSQI )
		return false;

	hSQI	= (HSQI)hStmt->hSQI;

	sprintf( hSQI->szMsg, "hStmt=%d", hStmt );
	logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, hSQI->szMsg );
	
	if ( !lstSeek( hSQI->hStmtList, hStmt ) )
	{
		sprintf( hSQI->szMsg, "Could not find hStmt (%d) in hSQI->hStmtList (%d)", hStmt, hSQI->hStmtList );
		logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_CRITICAL, SQI_ERROR, hSQI->szMsg );
		return false;
	}

	lstDelete( hSQI->hStmtList );	/* uses _sqiCloseStmt for free */

	logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, "Success" );

	return true;
}



