#include "sqi.h"

/********************************************
 * sqiOpen
 *
 ********************************************/
int sqiOpen( HSQI *phSQI, char *pszCatalogFile )
{
	HSQI 	hSQI;
	HLOG	hLog;

	if ( !pszCatalogFile )
		return false;
	
	if ( !logOpen( &hLog, "SQI", NULL, 20 ) )
		return false;

	hSQI = malloc( sizeof(SQI) );

	hSQI->hLog				= hLog;
	hSQI->hStmtList			= lstOpen();
	hSQI->pszCatalogFile	= (char*)strdup( pszCatalogFile );

	lstSetFreeFunc( hSQI->hStmtList, _sqiCloseStmt );

	/* LOAD TABLE CACHE, this will be done on server process startup in future versions */
	if ( !_sqiOpenDatabase( &hTableCache, pszCatalogFile ) )
	{
		logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_ERROR, "Had problems loading the database." );
	}
	
	/* finalize */
	*phSQI = hSQI;

	sprintf( hSQI->szMsg, "hSQI (%d) created for %s", hSQI, pszCatalogFile );
	logPushMsg( hSQI->hLog, __FILE__, __FILE__, __LINE__, LOG_INFO, SQI_SUCCESS, hSQI->szMsg );

	return true;
}



