#include "sqi.h"

int sqiStatistics( HSQISTMT hStmt, char *pszTableName )
{
	HSQI		hSQI;
	char		**pData;
	HSQICOLUMN	pColumn;

	if ( !hStmt )
		return false;
	
	if ( !pszTableName )
		return false;

	if ( hStmt->hTableResult )
		sqiFreeResult( hStmt );

	hSQI	= (HSQI)hStmt->hSQI;

	/************************
	 * BUILD RESULTS
	 ************************/
	hStmt->hTableResult 				= malloc( sizeof(SQITABLE) );

	hStmt->hTableResult->pszTableName	= (char*)strdup( "sqiStatistics" );
	hStmt->hTableResult->pszFileName	= NULL;
	hStmt->hTableResult->nRefs			= 0;
	hStmt->hTableResult->hBase			= NULL;

	/* table header */
	hStmt->hTableResult->hColHdrs	= lstOpen();
	lstSetFreeFunc( hStmt->hTableResult->hColHdrs, _sqiFreeColumnHeader );

	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 0, "system", "sqiStatistics", "TABLE_CAT" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 1, "system", "sqiStatistics", "TABLE_SCHEM" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 2, "system", "sqiStatistics", "TABLE_NAME" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 3, "system", "sqiStatistics", "NON_UNIQUE" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 4, "system", "sqiStatistics", "INDEX_QUALIFIER" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 5, "system", "sqiStatistics", "INDEX_NAME" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 6, "system", "sqiStatistics", "TYPE" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 7, "system", "sqiStatistics", "ORDINAL_POSITION" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 8, "system", "sqiStatistics", "COLUMN_NAME" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 9, "system", "sqiStatistics", "ASC_OR_DESC" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 10, "system", "sqiStatistics", "CARDINALITY" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 11, "system", "sqiStatistics", "PAGES" ) );
	lstAppend( hStmt->hTableResult->hColHdrs, _sqiNewColumnHeader( 12, "system", "sqiStatistics", "FILTER_CONDITION" ) );

	/* table rows (based upon root table col hdrs) */
	hStmt->hTableResult->hRows		= lstOpen();
	lstSetFreeFunc( hStmt->hTableResult->hRows, _sqiFreeDataRow );

	/* we would create rows here but no index support right now */

	/* finalize */
	hStmt->nRowsAffected	= hStmt->hTableResult->hRows->nItems;

	/* we should be EOL for call to fetch */
	lstLast( hStmt->hTableResult->hRows );
	lstNext( hStmt->hTableResult->hRows );

	return true;
}


